diff -Nur acpi.orig/acpica/acobject.h acpi/acpica/acobject.h
--- acpi.orig/acpica/acobject.h	2012-01-12 20:42:45.000000000 +0100
+++ acpi/acpica/acobject.h	2012-01-15 03:52:01.812784290 +0100
@@ -358,6 +358,7 @@
  */
 struct acpi_object_extra {
 	ACPI_OBJECT_COMMON_HEADER struct acpi_namespace_node *method_REG;	/* _REG method for this region (if any) */
+	struct acpi_namespace_node *scope_node;
 	void *region_context;	/* Region-specific data */
 	u8 *aml_start;
 	u32 aml_length;
diff -Nur acpi.orig/acpica/dsargs.c acpi/acpica/dsargs.c
--- acpi.orig/acpica/dsargs.c	2012-01-12 20:42:45.000000000 +0100
+++ acpi/acpica/dsargs.c	2012-01-15 03:52:38.980187009 +0100
@@ -384,7 +384,7 @@
 
 	/* Execute the argument AML */
 
-	status = acpi_ds_execute_arguments(node, node->parent,
+	status = acpi_ds_execute_arguments(node, extra_desc->extra.scope_node,
 					   extra_desc->extra.aml_length,
 					   extra_desc->extra.aml_start);
 	return_ACPI_STATUS(status);
diff -Nur acpi.orig/acpica/excreate.c acpi/acpica/excreate.c
--- acpi.orig/acpica/excreate.c	2012-01-12 20:42:45.000000000 +0100
+++ acpi/acpica/excreate.c	2012-01-15 03:53:48.059076919 +0100
@@ -330,6 +330,12 @@
 	region_obj2 = obj_desc->common.next_object;
 	region_obj2->extra.aml_start = aml_start;
 	region_obj2->extra.aml_length = aml_length;
+	if (walk_state->scope_info) {
+		region_obj2->extra.scope_node =
+			walk_state->scope_info->scope.node;
+	} else {
+		region_obj2->extra.scope_node = node;
+	}
 
 	/* Init the region from the operands */
 
